<template>
  <div class="container py-5">
    <div class="row">
      <div class="col-lg-6 ">
        <div class="contact text-left">
           <b-form-group id="input-group-1" :label="$t('name')+':'" label-for="name" class="mb-3">
            <b-form-input id="name" class="mb-3"  v-model="name" :placeholder="$t('namePlaceholder')"
            ></b-form-input>
          </b-form-group>
           <b-form-group id="input-group-1" :label="$t('email')+':'" label-for="email" :description="$t('emailDescription')" >
            <b-form-input id="email" class="mb-3"  v-model="email" v-model.trim="$v.email.$model" :type="'email'" :placeholder="$t('emailPlaceholder')"
            :class="{ 'is-invalid': !$v.email.email, 'is-valid': ($v.email.email && !$v.email.$invalid) }"
            ></b-form-input>
          </b-form-group>
           <b-form-group id="input-group-1" :label="$t('phone')+':'" label-for="phone">
            <b-form-input id="phone" class="mb-3"  v-model="phone" v-model.trim="$v.phone.$model" :type="'text'" :placeholder="$t('phonePlaceholder')"
            :class="{ 'is-invalid': (!$v.phone.validatePhone || !$v.phone.minLength ) && $v.phone.$model, 'is-valid': ($v.phone.validatePhone && $v.phone.minLength && $v.phone.$model) }"
            ></b-form-input>
          </b-form-group>
          <b-form-group id="input-group-1" :label="$t('country')+':'" label-for="country">
            <v-select :options="countryList" label="name" v-model="country" ></v-select>
          </b-form-group>
          <b-form-group id="input-group-1" :label="$t('message')+':'" label-for="message">
            <b-form-textarea
              id="message"
              class="mb-3"
              v-model="text"
              placeholder="Enter something..."
              rows="3"
              max-rows="6"
            ></b-form-textarea>
          </b-form-group>
          <b-button variant="outline-primary" @click="submitContactForm">{{$t('sendMessage')}}</b-button>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import { required, email, minLength } from 'vuelidate/lib/validators'
export default {
  created () {
    if (this.$store.state.status) {
      this.name = this.$store.getters.user.name
      this.email = this.$store.getters.user.email
    }
    this.$store.watch(
      (state) => {
        return this.$store.state
      },
      (newValue, oldValue) => {
        if (newValue) {
          this.setCountryListOptions()
          this.name = this.$store.getters.user.name
          this.email = this.$store.getters.user.email
        }
      },
      // Optional Deep if you need it
      {
        deep: true
      }
    )
  },
  mounted () {
    this.setCountryListOptions()
  },
  data () {
    return {
      name: '',
      activateLoader: false,
      email: '',
      phone: '',
      country: null,
      text: '',
      countryList: [],
      countryUpdated: false
    }
  },
  methods: {
    updateCountry: function (country) {
      this.country = country
    },
    submitContactForm: function () {
      this.activateLoader = true
      const message = {
        name: this.name,
        email: this.email,
        phonenumber: this.phone,
        country_code: this.country.id,
        text: this.text
      }
      console.log('message submitted:', message)
      setTimeout(() => {
        // Reset inputs
        this.name = ''
        this.email = ''
        this.phone = ''
        this.country = ''
        this.text = ''
        this.activateLoader = false
        this.$bvToast.toast(this.$t('ToastDescription'), {
          title: this.$t('toastTitle'),
          autoHideDelay: 5000
        })
      }, 1000)
    },
    setCountryListOptions: function () {
      const countryArr = [
        { id: 'TR', name: this.$t('TR') },
        { id: 'US', name: this.$t('US') },
        { id: 'GB', name: this.$t('GB') },
        { id: 'DE', name: this.$t('DE') },
        { id: 'SE', name: this.$t('SE') },
        { id: 'KE', name: this.$t('KE') },
        { id: 'BR', name: this.$t('BR') },
        { id: 'ZW', name: this.$t('ZW') }
      ]

      if (this.country && this.country.id) {
        const translatedCountry = countryArr.find((item) => {
          return item.id === this.country.id
        })
        this.updateCountry(translatedCountry)
      }

      this.countryList = countryArr
    }
  },
  validations: {
    email: {
      required, email
    },
    phone: {
      minLength: minLength(9),
      validatePhone: (phone) => {
        return /^[+]*[(]{0,1}[0-9]{1,3}[)]{0,1}[-\s./0-9]*$/.test(phone)
      }
    }
  }
}
</script>
